## Makefile for opal -- online learning algorithms with kernel slicing
##  $Id: makefile.opal 483 2010-09-16 12:59:22Z ynaga $
## Copyright (c) 2008-2010 Naoki Yoshinaga <ynaga@tkl.iis.u-tokyo.ac.jp>

CC     = ccache g++
SUF    =
TARGET = opal opal-prune opal-pmt opal-prune-pmt opalk rand_shuf

OBJS   = timer.o # uncomment when you unset USE_TIMER

WFLAGS = -Wall -Wno-deprecated -Wstrict-aliasing=2 -Wfloat-equal
CFLAGS = -O2 -m64 -march=core2 -DNDEBUG
# CFLAGS = -g -m64

default: clean all
all: $(TARGET)

opal: $(OBJS) makefile.opal
	$(CC) $(WFLAGS) $(CFLAGS) -DUSE_PRUNE -DUSE_PMT -o $@$(SUF) $(OBJS) opal.cpp
opal-prune: $(OBJS) makefile.opal
	$(CC) $(WFLAGS) $(CFLAGS) -DUSE_PMT -o $@$(SUF) $(OBJS) opal.cpp
opal-pmt: $(OBJS) makefile.opal
	$(CC) $(WFLAGS) $(CFLAGS) -DUSE_PRUNE -o $@$(SUF) $(OBJS) opal.cpp
opal-prune-pmt: $(OBJS) makefile.opal
	$(CC) $(WFLAGS) $(CFLAGS) -o $@$(SUF) $(OBJS) opal.cpp
opalk: $(OBJS) makefile.opal
	$(CC) $(WFLAGS) $(CFLAGS) -DUSE_PolyK -o $@$(SUF) $(OBJS) opal.cpp
rand_shuf: rand_shuf.cpp makefile.opal
	$(CC) $(WFLAGS) $(CFLAGS) -o $@$(SUF) rand_shuf.cpp
.cpp.o:
	$(CC) -c $(WFLAGS) $(CFLAGS) $<

timer.o: timer.h makefile.opal

clean:
	rm -f $(TARGET) $(OBJS)

